﻿//ALL CLASSES NEED THIS
package {
	//WE NEED THESE IMPORTED FOR THE PROGRAM TO RUN
	import flash.display.MovieClip;
	import flash.events.*;

	//THIS MAKES EACH SHOT ACT AS A MOVIECLIP
	public class Gem extends MovieClip {

		//VARIABLES

		//Defining _root for use as the root of the game
		private var _root:Object;

		//THIS WILL RUN FOR EVERY SHOT ADDED TO THE GAME
		public function Gem() {
			//ADDING EVENT THAT WILL ONLY RUN ONCE
			// (WHEN THE OBJECT IS ADDED)
			addEventListener(Event.ADDED, beginClass);

			//EVENT THAT WILL RUN EVERY FRAME
			addEventListener(Event.ENTER_FRAME, eFrame);
		}


		//SETTING _root AS THE ROOT
		private function beginClass(event:Event):void {
			_root=MovieClip(root);
		}


		//ON EVERY FRAME
		private function eFrame(event:Event):void {


			//HIT TEST WITH PLAYER
			if (hitTestObject(_root.mcMain)) {
				_root.score+=10;
				//REMOVE LISTENERS
				removeEventListener(Event.ENTER_FRAME, eFrame);
				//REMOVE SELF FROM STAGE
				this.parent.removeChild(this);
			}


			//CHECK FOR GAMEOVER
			if (_root.gameOver) {
				//REMOVE LISTENERS
				removeEventListener(Event.ENTER_FRAME, eFrame);
				//REMOVE SELF FROM STAGE
				this.parent.removeChild(this);
			}
			//CHECK FOR GAMEOVER
			if (_root.resetting) {
				//REMOVE LISTENERS
				removeEventListener(Event.ENTER_FRAME, eFrame);
				//REMOVE SELF FROM STAGE
				this.parent.removeChild(this);
			}
		}

		//HOW TO REMOVE LISTENERS WITH A SHORT CALL
		public function removeListeners():void {
			this.removeEventListener(Event.ENTER_FRAME, eFrame);
		}
	}
}